#include <iostream>
#include <string>
using namespace std ;
const int INF = 1000000000 ;
const int MOD = 10000019 ;
int sum ;
int ok(const string &a, const string &b, int off, string &t) {
   int n = (int)a.size() ;
   for (int i=0; i<off; i++)
      if (a[i+n-off] == b[i])
         return 0 ;
   for (int i=off; i<n; i++)
      if (a[i-off] == b[i])
         return 0 ;
   for (int i=0; i<off; i++)
      t[i+n-off] = sum - a[i+n-off] - b[i] ;
   for (int i=off; i<n; i++)
      t[i-off] = sum - a[i-off] - b[i] ;
   return 1 ;
}
int mhash(const string &a) {
   int r = 0 ;
   for (auto v : a)
      r = (37 * r + v) % MOD ;
   return r ;
}
int eq(const string &a, const string &b, int off) {
   int n = (int)a.size() ;
   for (int i=0; i<off; i++)
      if (a[i+n-off] != b[i])
         return 0 ;
   for (int i=off; i<n; i++)
      if (a[i-off] != b[i])
         return 0 ;
   return 1 ;
}
int main() {
   int n ;
   string a, b, c ;
   cin >> a >> b >> c ;
   n = a.size() ;
   int r = INF ;
   string t ;
   t.resize(n) ;
   sum = 'A' + 'B' + 'C' ;
   int h = mhash(c) ;
   int hm = 1 ;
   for (int i=0; i<n; i++)
      hm = hm * 37 % MOD ;
   hm -= 1 ;
   hm = (MOD - hm) % MOD ;
   for (int i=0; i<n; i++)
      if (ok(a, b, i, t)) {
         int hgoal = mhash(t) ;
         for (int j=0; j<n; j++) {
            int k = (i - j + n) % n ;
            int ii = min(i, n-i) ;
            int jj = min(j, n-j) ;
            int kk = min(k, n-k) ;
            int tr = min(min(ii+jj, ii+kk), jj+kk) ;
            if (tr < r && h == hgoal && eq(t, c, j))
               r = tr ;
            h = (h * 37 + hm * c[j]) % MOD ;
         }
      }
   cout << (r==INF?-1:r) << endl ;
}
