import java.util.*;

public class letterwheels_tbuzzelli {

	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = 5000;
		char[][] arr = new char[3][n];
		boolean[][][] good = new boolean[3][3][n];
		for (int i = 0; i < 3; i++) {
			String str = in.next();
			n = str.length();
			arr[i] = str.toCharArray();
		}
		for (boolean[][] a : good) for (boolean[] b : a) Arrays.fill(b, true);
		for (int a = 0; a < 3; a++) {
			for (int b = a + 1; b < 3; b++) {
				for (int shift = 0; shift < n; shift++) {
					for (int i = 0; i < n; i++) {
						if (arr[a][i] == arr[b][(i + shift) % n]) {
							good[a][b][shift] = false;
							break;
						}
					}
				}
			}
		}
		int oo = 1000000000;
		int[][] dist = new int[n][n];
		for (int[] a : dist) Arrays.fill(a, oo);
		dist[0][0] = 0;
		ArrayDeque<Integer> q = new ArrayDeque<>(n * n);
		q.add(0);
		q.add(0);
		while (!q.isEmpty()) {
			int a = q.poll();
			int b = q.poll();
			for (int da = -1; da <= 1; da++) {
				for (int db = -1; db <= 1; db++) {
					int na = (a + da + n) % n;
					int nb = (b + db + n) % n;
					if (da * db == -1) continue;
					if (dist[na][nb] == oo) {
						dist[na][nb] = dist[a][b] + 1;
						q.add(na);
						q.add(nb);
					}
				}
			}
		}
		int ans = oo;
		for (int s1 = 0; s1 < n; s1++) {
			if (!good[0][1][s1]) continue;
			for (int s2 = 0; s2 < n; s2++) {
				int s3 = (s2 - s1 + n) % n;
				if (!good[0][2][s2] || !good[1][2][s3]) continue;
				ans = Math.min(ans, dist[s1][s2]);
			}
		}
		System.out.println(ans == oo ? -1 : ans);
	}
	
}
