#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int, int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1e9;

int main() {
	string s[3];
	REP(i,0,3) cin >> s[i];
	int n = s[0].size();
	int ans = INF;
	REP(i,0,3) {
		int j = (i + 1) % 3;
		int k = ((i + 1) ^ (j + 1)) - 1;
		map<string, int> mink;
		mink.clear();
		REP(r,0,n) {
			int nr = min(r, n - r);
			auto it = mink.find(s[k]);
			if (it == mink.end() || it->second > nr) mink[s[k]] = nr;
			rotate(s[k].begin(), s[k].begin() + 1, s[k].end());
		}
		REP(r,0,n) {
			bool ok = true;
			string need = "";
			REP(p,0,n) {
				if (s[i][p] == s[j][p]) {
					ok = false;
					break;
				}
				need += 'A' + ((s[i][p] - 'A' + 1) ^ (s[j][p] - 'A' + 1)) - 1;
			}
 			if (ok && mink.find(need) != mink.end()) {
				int sol = min(r, n - r) + mink[need];
				ans = min(ans, sol);
			}
			rotate(s[j].begin(), s[j].begin() + 1, s[j].end());
		}
	}
	cout << (ans == INF ? -1 : ans) << endl;
	return 0;
}