#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

constexpr int MAXN = 5000;
int n;
int cost[MAXN];
string s[3];

bool check(int a, int b, int off1, int off2) {
    for (int i = 0; i < n; ++i) {
        int idx1 = off1 + i;
        int idx2 = off2 + i;
        if (idx1 >= n)
            idx1 -= n;
        if (idx2 >= n)
            idx2 -= n;
        if (s[a][idx1] == s[b][idx2])
            return false;
    }

    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> s[0] >> s[1] >> s[2];
    n = s[0].size();

    for (int i = 0; i < n; ++i) {
        cost[i] = min(i, n - i);
    }

    constexpr int INF = 1e9;
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int first = cost[i] + cost[j];
            if (first >= ans or !check(0, 1, i, j)) continue;
            for (int k = 0; k < n; ++k) {
                int cur = first + cost[k];
                if (cur >= ans) continue;
                if (check(0, 2, i, k) and check(1, 2, j, k)) {
                    ans = cur;
                }
            }
        }
    }

    if (ans == INF)
        ans = -1;

    cout << ans << '\n';
}
