#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int, int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1e9;

int main() {
	string s[3];
	REP(i,0,3) cin >> s[i];
	int n = s[0].size();
	map<string, int> lastPos;
	lastPos[s[2]] = 0;
	REP(i,1,n) {
		rotate(s[2].begin(), s[2].begin() + 1, s[2].end());
		lastPos[s[2]] = i; // WA: does not handle multiple ways to rotate that give a same result
	}
	int ans = INF;
	REP(i,0,n) {
		bool ok = true;
		string need = "";
		REP(j,0,n) {
			if (s[0][j] == s[1][j]) {
				ok = false;
				break;
			}
			need += 'A' + ((s[0][j] - 'A' + 1) ^ (s[1][j] - 'A' + 1)) - 1;
		}
		if (ok && lastPos.find(need) != lastPos.end()) {
		  int rot[3] = { 0, i, lastPos[need] };
			REP(b,0,n) {
				int sol = min(rot[0], n - rot[0]) + min(rot[1], n - rot[1]) + min(rot[2], n - rot[2]);
				ans = min(ans, sol);
				REP(t,0,3) rot[t] = rot[t] + 1 == n ? 0 : rot[t] + 1;
			}
		}
		rotate(s[1].begin(), s[1].begin() + 1, s[1].end());
	}
	cout << (ans == INF ? -1 : ans) << endl;
	return 0;
}
